import java.util.*;
import java.io.*;


public class LogFileInfo extends TimerTask
{
   private LogInfoCallback logInfoCallback = null;
   
   public void setLogInfoCallBack(LogInfoCallback pLogInfoCallback)
   {
       logInfoCallback = pLogInfoCallback;
   }
   
   private long crtSize = 0;

   public long getCrtSize()
   {
      return this.crtSize;
   }

   public void setCrtSize(long value)
   {
      if (this.crtSize != value)
      {
         
         this.crtSize = value;
         
      }
   }

   private Date crtTime = null;

   public Date getCrtTime()
   {
      return this.crtTime;
   }

   public void setCrtTime(Date value)
   {
      if (this.crtTime != value)
      {
         
         this.crtTime = value;
         
      }
   }

   private String filePath = null;

   public String getFilePath()
   {
      return this.filePath;
   }

   public void setFilePath(String value)
   {
      if (this.filePath != value)
      {
         
         this.filePath = value;
         
      }
   }
   
   public void run()
   {    
       /*Random gen = new Random();
       int size = gen.nextInt(4) + 1;
       String[] logLines = new String[size];
       
       for (int i = 0; i < size; i++)
       {
           logLines[i] = String.valueOf(System.currentTimeMillis());
       }*/
       
       if (this.filePath == null || this.filePath.length() == 0)
           return;
       
       String[] logLines = null;
       BufferedReader input = null;
       long newSize = 0;
       Date newModifTime = null;
       try
       {
           File logFile = new File(filePath);
           newSize = logFile.length();
           newModifTime = new Date(logFile.lastModified());
           if (!((this.crtSize == 0 && this.crtTime == null) ||
                   (this.crtSize >= newSize || this.crtTime == newModifTime))) //there are differences
           {               
                input = new BufferedReader(new FileReader(logFile));
                input.skip(this.crtSize);
                long noLines = 0;
                String line = null;
                ArrayList<String> lineList = new ArrayList<String>();
                while (( line = input.readLine()) != null)                    
                    lineList.add(line);                              
                logLines = new String[1];
                logLines = lineList.toArray(logLines);
           }        
       }
       catch (Exception e)
       {
           logLines = new String[1];
           logLines[0] = "*Error* " + e.getMessage();
       }
       finally
       {
           this.crtSize = newSize;
           this.crtTime = newModifTime;
           try
           {
               if (input != null)
                   input.close();
           }
           catch (Exception e)
           {
               
           }
       }
       
       if (this.logInfoCallback != null && logLines != null)
            this.logInfoCallback.callback(logLines);
   }

}
