/*
 * MainFrame.java
 *
 * Created on February 5, 2006, 6:48 PM
 */
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.awt.*;
import java.io.*;
/**
 *
 * @author  paul
 */
public class MainFrame extends javax.swing.JFrame {
    
    private java.util.Timer timer;
    private int timerSchedule = 1000;
    private javax.swing.JTextArea txtSelection;
    private boolean started = true;
    
    final String propFile = "defaultProperties";
    Properties defProp = new Properties();
    
    /** Creates new form MainFrame */
    private LogFileInfo logFileInfo = new LogFileInfo();
        
    
    public MainFrame() {
        initComponents();
        this.setSize(800, 600);        
        
        txtSelection = new javax.swing.JTextArea();
        txtSelection.setLineWrap(true);
        txtSelection.setForeground(Color.blue);        
        getContentPane().add(txtSelection, java.awt.BorderLayout.CENTER);                            
        
        
        
        boolean mySql = true;        
        try
        {
            FileInputStream in = new FileInputStream(propFile);
            defProp.load(in);
            in.close();
            String tmp = defProp.getProperty("MySQL", "1");
            if (tmp.compareTo("1") == 0)
                mySql = true;
            else if (tmp.compareTo("0") == 0)
                mySql = false;     
            logFileInfo.setFilePath(defProp.getProperty("LogFile", ""));
            tmp = defProp.getProperty("timerSchedule", "1000");
            timerSchedule = Integer.parseInt(tmp);
        }
        catch (Exception e)
        {
            
        }
        
        logFileInfo.setLogInfoCallBack(new LogInfoCallback() {
            public void callback(String[] logLines) {
                processNewLogEntries(logLines);
            }
        });
        
        timer = new java.util.Timer();
        timer.schedule(logFileInfo, timerSchedule, timerSchedule);
        
        this.mnuMySQL.setState(mySql);
        setTblLog(mySql);
        
        tblLog.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e)
            {
                LogEntry dummy = null;
                if (mnuMySQL.getState())
                    dummy = new MySQLLogEntry("");
                else
                    dummy = new LogEntry("");
                
                int lastIdx = tblLog.getSelectedRow();
                if (lastIdx >= 0)
                {
                    String selection = (String)tblLog.getValueAt(lastIdx, dummy.getSelectionColumn());
                    txtSelection.setText(selection);                
                }
            }
        });
        
        onStart(null);        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    private void setTblLog(boolean bMySQL)
    {
        LogEntry header = null;
        if (bMySQL)
            header = new MySQLLogEntry("");
        else
            header = new LogEntry("");
                
        String [] hStrings = new String[header.getColumnCount()];
        for (byte i = 0; i < header.getColumnCount(); i++)
        {        
            hStrings[i] = header.getHeaderCol(i);
        }
        tblLog.setModel(new javax.swing.table.DefaultTableModel(
            null,
            hStrings
            ));

        for (byte i = 0; i < header.getColumnCount(); i++)
        {
            if (header.getPreferedWidthCol(i) >= 0)
                tblLog.getColumnModel().getColumn(i).setPreferredWidth(header.getPreferedWidthCol(i));
        }                           
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        tlBar = new javax.swing.JToolBar();
        btnStart = new javax.swing.JButton();
        btnStop = new javax.swing.JButton();
        btnReset = new javax.swing.JButton();
        jSeparator = new javax.swing.JSeparator();
        btnExit = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();
        tblLog = new javax.swing.JTable();
        mnuBar = new javax.swing.JMenuBar();
        mnuFile = new javax.swing.JMenu();
        mnuStart = new javax.swing.JMenuItem();
        mnuStop = new javax.swing.JMenuItem();
        mnuReset = new javax.swing.JMenuItem();
        mnuExit = new javax.swing.JMenuItem();
        mnuOptions = new javax.swing.JMenu();
        mnuPath = new javax.swing.JMenuItem();
        mnuMySQL = new javax.swing.JCheckBoxMenuItem();
        mnuTimerSchedule = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("LogMonitor");
        setIconImage((new javax.swing.ImageIcon(getClass().getResource("/book.gif"))).getImage());
        setName("mainFrame");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                OnClosing(evt);
            }
        });

        btnStart.setIcon(new javax.swing.ImageIcon(getClass().getResource("/start.GIF")));
        btnStart.setText("Start");
        btnStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onBtnStart(evt);
            }
        });

        tlBar.add(btnStart);

        btnStop.setIcon(new javax.swing.ImageIcon(getClass().getResource("/stop.gif")));
        btnStop.setText("Stop");
        btnStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onBtnStop(evt);
            }
        });

        tlBar.add(btnStop);

        btnReset.setIcon(new javax.swing.ImageIcon(getClass().getResource("/reset.gif")));
        btnReset.setText("Reset");
        btnReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onBtnReset(evt);
            }
        });

        tlBar.add(btnReset);

        tlBar.add(jSeparator);

        btnExit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/exit.gif")));
        btnExit.setText("Exit");
        btnExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onBtnExit(evt);
            }
        });

        tlBar.add(btnExit);

        getContentPane().add(tlBar, java.awt.BorderLayout.SOUTH);

        tblLog.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        getContentPane().add(tblLog.getTableHeader(), java.awt.BorderLayout.NORTH);
        scrollPane.setViewportView(tblLog);

        getContentPane().add(scrollPane, java.awt.BorderLayout.NORTH);

        mnuFile.setText("File");
        mnuFile.setDisplayedMnemonicIndex(0);
        mnuFile.setName("mnuFile");
        mnuFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onReset(evt);
            }
        });

        mnuStart.setText("Start");
        mnuStart.setDisplayedMnemonicIndex(0);
        mnuStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onStart(evt);
            }
        });

        mnuFile.add(mnuStart);

        mnuStop.setText("Stop");
        mnuStop.setDisplayedMnemonicIndex(1);
        mnuStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onStop(evt);
            }
        });

        mnuFile.add(mnuStop);

        mnuReset.setText("Reset");
        mnuReset.setActionCommand("cmdReset");
        mnuReset.setDisplayedMnemonicIndex(0);
        mnuReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onReset(evt);
            }
        });

        mnuFile.add(mnuReset);

        mnuExit.setText("Exit");
        mnuExit.setActionCommand("cmdExit");
        mnuExit.setDisplayedMnemonicIndex(0);
        mnuExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onExit(evt);
            }
        });

        mnuFile.add(mnuExit);

        mnuBar.add(mnuFile);

        mnuOptions.setText("Options");
        mnuOptions.setDisplayedMnemonicIndex(0);
        mnuOptions.setName("mnuOptions");
        mnuPath.setText("Log file path");
        mnuPath.setDisplayedMnemonicIndex(9);
        mnuPath.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onChoosePath(evt);
            }
        });

        mnuOptions.add(mnuPath);

        mnuMySQL.setSelected(true);
        mnuMySQL.setText("structured log");
        mnuMySQL.setDisplayedMnemonicIndex(0);
        mnuMySQL.setIcon(new javax.swing.ImageIcon(getClass().getResource("/mysql.gif")));
        mnuMySQL.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onToggleMySQL(evt);
            }
        });

        mnuOptions.add(mnuMySQL);

        mnuTimerSchedule.setText("Timer schedule");
        mnuTimerSchedule.setDisplayedMnemonicIndex(0);
        mnuTimerSchedule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                onTimerSchedule(evt);
            }
        });

        mnuOptions.add(mnuTimerSchedule);

        mnuBar.add(mnuOptions);

        setJMenuBar(mnuBar);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    private void onBtnExit(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onBtnExit
        onExit(null);
    }//GEN-LAST:event_onBtnExit

    private void onBtnReset(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onBtnReset
        onReset(null);
    }//GEN-LAST:event_onBtnReset

    private void onBtnStop(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onBtnStop
        this.onStop(null);
    }//GEN-LAST:event_onBtnStop

    private void onBtnStart(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onBtnStart
        this.onStart(null);
    }//GEN-LAST:event_onBtnStart

    private void onStop(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onStop
        this.mnuStart.setEnabled(true);
        this.btnStart.setEnabled(true);
        this.mnuStop.setEnabled(false);
        this.btnStop.setEnabled(false);
        started = false;
    }//GEN-LAST:event_onStop

    private void onStart(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onStart
        this.mnuStart.setEnabled(false);
        this.btnStart.setEnabled(false);
        this.mnuStop.setEnabled(true);
        this.btnStop.setEnabled(true);
        started = true;
        this.txtSelection.setText("");                
        if (!checkLogFile())
            onStop(null);
    }//GEN-LAST:event_onStart

    private void onTimerSchedule(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onTimerSchedule
        String s = (String)JOptionPane.showInputDialog(
                this,
                "Log refresh period (ms)",
                String.valueOf(this.timerSchedule)
        );
        if (s != null && s.length() > 0)
        {
            try
            {
                this.timerSchedule = Integer.parseInt(s);                
                JOptionPane.showMessageDialog(this, "Log refresh period changed. Restart LogReader for the chages to take effect!", "Information", JOptionPane.INFORMATION_MESSAGE);
            }
            catch (Exception e)
            {
                JOptionPane.showMessageDialog(this, "You entered an invalid refresh period!", "Error", JOptionPane.ERROR_MESSAGE);
            }                        
        }
    }//GEN-LAST:event_onTimerSchedule

    private void onReset(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onReset
        onToggleMySQL(null);
        this.txtSelection.setText("");                
    }//GEN-LAST:event_onReset

    private void onChoosePath(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onChoosePath
        JFileChooser fc = new JFileChooser(this.logFileInfo.getFilePath());
        int returnVal = fc.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION)
        {
            File file = fc.getSelectedFile();
            this.logFileInfo.setFilePath(file.getAbsolutePath());
            onStop(null);
            onStart(null);            
        }
    }//GEN-LAST:event_onChoosePath

    private void OnClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_OnClosing
        onExit(null);
    }//GEN-LAST:event_OnClosing

    private void onExit(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onExit
        try
        {
            String tmp = (this.mnuMySQL.getState() ? "1" : "0");
            defProp.setProperty("MySQL", tmp);
            defProp.setProperty("LogFile", logFileInfo.getFilePath());            
            defProp.setProperty("timerSchedule", String.valueOf(this.timerSchedule));
            FileOutputStream out = new FileOutputStream(this.propFile);
            this.defProp.store(out, "--no comment--");
            out.close();
            
        }
        catch (Exception e)
        {
            
        }
        System.exit(0);
    }//GEN-LAST:event_onExit

    private void onToggleMySQL(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onToggleMySQL
        setTblLog(this.mnuMySQL.getState());        
    }//GEN-LAST:event_onToggleMySQL
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        try
        {
            UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        }
        catch(Exception e)
        {
            
        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnExit;
    private javax.swing.JButton btnReset;
    private javax.swing.JButton btnStart;
    private javax.swing.JButton btnStop;
    private javax.swing.JSeparator jSeparator;
    private javax.swing.JMenuBar mnuBar;
    private javax.swing.JMenuItem mnuExit;
    private javax.swing.JMenu mnuFile;
    private javax.swing.JCheckBoxMenuItem mnuMySQL;
    private javax.swing.JMenu mnuOptions;
    private javax.swing.JMenuItem mnuPath;
    private javax.swing.JMenuItem mnuReset;
    private javax.swing.JMenuItem mnuStart;
    private javax.swing.JMenuItem mnuStop;
    private javax.swing.JMenuItem mnuTimerSchedule;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JTable tblLog;
    private javax.swing.JToolBar tlBar;
    // End of variables declaration//GEN-END:variables
    
    void processNewLogEntries(String[] logLines)
    {        
        if (!started)
            return;
        for (int i = 0; i < logLines.length; i++)
        {
            LogEntry logEntry = null;
            if (this.mnuMySQL.getState())
                logEntry = new MySQLLogEntry(logLines[i]);
            else
                logEntry = new LogEntry(logLines[i]);
            Object[] rowData = new Object[logEntry.getColumnCount()];            
            for (byte j = 0; j < logEntry.getColumnCount(); j++)
                rowData[j] = logEntry.getDataCol(j);
            ((DefaultTableModel)tblLog.getModel()).addRow(rowData);            
        }
        
        int count = ((DefaultTableModel)tblLog.getModel()).getRowCount();            
        tblLog.getSelectionModel().setSelectionInterval(count - 1, count - 1);
        
        tblLog.invalidate();
        Rectangle rec = tblLog.getCellRect(count - 1, 0, true);
        tblLog.scrollRectToVisible(rec);                
        
    }
    
    boolean checkLogFile()
    {
        //verify log file
        boolean ret = true;
        if (this.logFileInfo.getFilePath() == null || this.logFileInfo.getFilePath().length() == 0)
        {
            this.txtSelection.setText("*Error* Log file not defined!");                            
            ret = false;
        }
        else
        {        
            File logFile = new File(this.logFileInfo.getFilePath());
            if (!logFile.canRead())
            {
                this.txtSelection.setText("*Error* Not able to read the log file!");                            
                ret = false;
            }
        }
                    
        if (!ret)
            onStop(null);
        return true;
    }
}
