import java.util.Date;
import java.util.*;

public class MySQLLogEntry
extends LogEntry
{
   private String command;
   private static HashMap<String, String> sMap = new HashMap<String, String>();

   protected String getCommand()
   {
      return this.command;
   }

   protected void setCommand(String value)
   {
      if (this.command != value)
      {
         
         this.command = value;
         
      }
   }

   private String connection;

   protected String getConnection()
   {
      return this.connection;
   }

   protected void setConnection(String value)
   {
      if (this.connection != value)
      {
         
         this.connection = value;
         
      }
   }

   
   static private String prevStarted;
   private String started = null;

   protected String getStarted()
   {
      return this.started;
   }

   protected void setStarted(String value)
   {
      if (this.started != value)
      {
         
         this.started = value;
         
      }
   }

   private String type;

   protected String getType()
   {
      return this.type;
   }

   protected void setType(String value)
   {
      if (this.type != value)
      {
         
         this.type = value;
         
      }
   }

   public MySQLLogEntry(String strEntry)
   {
       super(strEntry);
       Parse();
   }

   private void Parse()
   {
       try
       {
           String mainParts[] = this.getStringEntry().split("\t");           
           for (int i = 0; i < mainParts.length; i++)               
                mainParts[i].trim();
           this.setStarted(mainParts[0].length() > 0 ? mainParts[0] : this.prevStarted);
           if (mainParts[0].length() > 0)
               this.prevStarted = mainParts[0];
           String details = mainParts[mainParts.length - 1].trim();
           int idxCrtField = 0;
           String crtField = "";
           for (int i = 0; i < details.length(); i++)
           {
               char crt = details.charAt(i);
               if (crt == ' ' && idxCrtField < 2)
               {
                   if (idxCrtField == 0)                   
                       setConnection(crtField.trim());
                   else
                       setType(crtField.trim());
                   crtField = "";
                   idxCrtField++;
               }
               else
                   crtField += crt;
           }
           if (idxCrtField == 1)
                setType(crtField.trim());
           else               
                setCommand(crtField.trim());                         
           
           //cache the connection
           if (getType().compareToIgnoreCase("connect") == 0)
           {
               sMap.put(getConnection(), getCommand());
           }
       }
       catch(Exception e)
       {
           setType("*ERROR*");
           setCommand(e.toString());           
       }
   }

   public byte getSelectionColumn()
   {
       return 3;
   }
   
   public byte getColumnCount()
   {
       return 4;
   }

   public String getDataCol(byte idx)
   {
       String ret = "";
       switch (idx)
       {
           case 0:
               ret = this.getStarted();
               break;
           case 1:
               if (sMap.containsKey(this.getConnection()))
                    ret = sMap.get(this.getConnection());
               else
                    ret = this.getConnection();
               break;
           case 2:
               ret = this.getType();
               break;
           case 3:
               ret = this.getCommand();
               break;                                         
           default:
               ret = "";
               break;
       }
       return ret;
   }

   public String getHeaderCol(byte idx)
   {
       String ret = "";
       switch (idx)
       {
           case 0:
               ret = "Started";
               break;
           case 1:
               ret = "Connection";
               break;
           case 2:
               ret = "Type";
               break;
           case 3:
               ret = "Command";
               break;                                         
           default:
               ret = "";
               break;
       }
       return ret;
   }
   
   public int getPreferedWidthCol(byte idx)
   {       
       int ret = 0;
       switch (idx)
       {
           case 0:
               ret = 40;
               break;
           case 1:
               ret = 40;
               break;
           case 2:
               ret = 20;
               break;
           case 3:
               ret = 300;
               break;                                         
           default:
               ret = 0;
               break;
       }
       return ret;
   }

}
